**$NOKEYWORDS$
************************************
* Version controll commands and functions 
* SourceSafe
************************************
*****************
* User commands
*****************
*Add and remove users
FUNCTION ssadmin
PRIVATE cDir,nArea
nArea = SELECT()
SELE 0
USE DB_STAT ALIAS DB_STAT
m.admindir = db_stat->admindir
USE IN db_stat
* Check in admin directory is valid 
IF NOT CheckDir(m.admindir)
   WAIT WINDOW "Locate SourceSafe Admin directory from CAPCON Preferences." NOWAIT
   SELECT (nArea)
   RETURN
ENDIF
=SETDIR(m.admindir)
!ADMIN   && For new SourceSafe change to SSADMIN command
SELECT (nArea)
=SETDIR(home_dir)

***************************
* Projects Commands *
***************************
*Add new project
PROCEDURE ssaddproj
PARAMETERS cProject
DO setbat 
\@echo off
\ECHO Adding project <<cProject>> to Source Safe... 
\SS CP $/  
\SS CREATE $/<<cProject>> -C- -S
DO doresbat

*Remove project
PROCEDURE ssremproject
PARAMETERS cProject
DO setbat 
\@echo off
\ECHO Removing project <<cProject>> from Source Safe... 
\SS CP $/ 
\SS REMOVE $/<<cProject>> 
\SS PURGE  $/<<cProject>> 
DO doresbat

*Select project
PROCEDURE ssseleproject
PARAMETERS cProject
DO setbat 
\@echo off
\ECHO Sets the current Source Safe project to <<cProject>>... 
\SS CP $/ 
\SS CP $/<<cProject>>  
DO doresbat

FUNCTION setbat
* Define header of batch file
IF FILE(cWorkFilDir+"setall.bat")
     SET TEXT TO
     SET TEXT OFF
     DELETE FILE (cWorkFilDir+"setall.bat")
ENDIF
SET TEXT ON 
SET TEXT TO (cWorkFilDir+"setall.bat") ADDITIVE  NOSHOW
\@echo off
\rem > chkerr.err

FUNCTION doresbat
* Do and reset 
SET TEXT TO
SET TEXT OFF
ACTI SCREEN
=SETDIR(cWorkFilDir)
DO runbat WITH "setall" IN fproc.prg
IF m_erasebat
  DELETE FILE setall.bat
ENDIF
=SETDIR(home_dir)

*********************************
*Module commands and functions
*********************************

* COMMANDS

* Add New Module command
FUNCTION fAdd
RETURN('SS ADD {FILE} -C- ')

* Add New Module command
FUNCTION fRemove
RETURN('SS REMOVE {FILE} ')

FUNCTION fPurge
RETURN('SS PURGE {FILE} ')


FUNCTION fShare
RETURN('SS SHARE $\{PROJECT}\{FILE} ')

* Check In command
FUNCTION fCheckin
*RETURN ('SS UPDATE {FILE} -C{COMMENT} -W- ')
RETURN ('SS UPDATE {FILE} -I- -C{COMMENTS}')

* Check In and Lock
FUNCTION fChlock
RETURN ('SS UPDATE {FILE} -I- -K -C-}')

* Check Out command
FUNCTION fCheckout
RETURN('SS CHECKOUT {FILE} ')

* Restore command
FUNCTION fRestore
RETURN('SS GET {FILE}  -W -V{VERSION}')

* History report command
FUNCTION fHistory
RETURN('SS HISTORY {FILE} ')

* History report command for latest version
FUNCTION fcheckver
RETURN('SS HISTORY {FILE} ')

* Status report command
FUNCTION fStatus
RETURN('SS STATUS {FILE}  ')

* FUNCTIONS

* Add and Check In module
FUNCTION AddNew
PARAMETERS filename
PRIVATE m.add
m.add = STRTRAN(m_add,"{FILE}",filename)
RETURN(ALLTRIM(m.add))

* Add and Keep Locked
FUNCTION AddNewLock
PARAMETERS filename
PRIVATE m.add
m.add = STRTRAN(m_add,"{FILE}",filename)
RETURN(ALLTRIM(m.add))

* Remove file from the project
FUNCTION RemoveFile
PARAMETERS filename
PRIVATE m.remove
m.remove = STRTRAN(m_remove,"{FILE}",filename)
RETURN(ALLTRIM(m.remove))

* Permanently delete a Removed file from the project
FUNCTION PurgeFile
PARAMETERS filename
PRIVATE m.purge
m.purge = STRTRAN(m_purge,"{FILE}",filename)
RETURN(ALLTRIM(m.purge))

* Share modules
FUNCTION sharemode
PARAMETERS filename,cProjname
PRIVATE cFile
cFile = SUBSTR(filename,RAT("\",filename)+1)
m.share = STRTRAN(m_share,"{FILE}",cFile)
m.share = STRTRAN(m.share,"{PROJECT}",cProjname)
RETURN (ALLTRIM(m.share))


* Check In module
FUNCTION checkin
PARAMETERS filename
PRIVATE m.checkin,cFile
cFile = SUBSTR(filename,RAT("\",filename)+1)
m.checkin = STRTRAN(m_checkin,"{FILE}",cFile)
m.checkin = ALLTRIM(SUBSTR(m.checkin,1,AT("-C",m.checkin)-1))
RETURN(ALLTRIM(m.checkin))

* Check In module and lock
FUNCTION checkinlock
PARAMETERS filename
PRIVATE m.checkin,cFile
cFile = SUBSTR(filename,RAT("\",filename)+1)
m.checkin = STRTRAN(fChlock(),"{FILE}",cFile)
m.checkin = ALLTRIM(SUBSTR(m.checkin,1,AT("-C",m.checkin)-1))
RETURN(ALLTRIM(m.checkin))

* Check In module without comment
FUNCTION checkinnc
PARAMETERS filename
PRIVATE m.checkin,cFile
cFile = SUBSTR(filename,RAT("\",filename)+1)
m.checkin = STRTRAN(m_checkin,"{FILE}",cFile)
m.checkin = ALLTRIM(SUBSTR(m.checkin,1,AT("-C",m.checkin)-1))
RETURN(ALLTRIM(m.checkin))

* Check Out module 
FUNCTION checkout
PARAMETERS filename,m.checkout
cFile = SUBSTR(filename,RAT("\",filename)+1)
m.checkout = STRTRAN(m_checkout,"{FILE}",cFile)
RETURN(m.checkout)

* Restore module 
FUNCTION restore
PARAMETERS filename
PRIVATE m.restore,cFile
cFile = SUBSTR(filename,RAT("\",filename)+1)
m.restore = STRTRAN(fRestore(),"{FILE}",cFile)
m.restore = STRTRAN(m.restore,"{VERSION}",cVer)
RETURN(m.restore)

FUNCTION setresp
PRIVATE m.commentline, nArea, lCommCursorYes
lCommCursorYes = .F.
IF USED("comments")
    nArea = SELECT()
    SELE comments
    SET ORDER TO name
    IF SEEK(current.name)
        m.commentline = ALLTRIM(comments.comments)
        m.commentline = STRTRAN(m.commentline,CHR(13)," ")
        m.commentline = STRTRAN(m.commentline,CHR(10)," ")
        IF LEN(m.commentline) > 100
          m.commentline = SUBSTR(m.commentline,1,100)
        ENDIF   
        \ECHO  <<m.commentline>> > COMMRESP.
        lCommCursorYes = .T.
    ENDIF
    SELECT (nArea)
ENDIF
IF NOT lCommCursorYes 
 IF  EMPTY(m.groupcomm) .OR. TYPE("m.groupcomm") <> "C"
    m.commentline = comments
    IF m_delimiter $ m.commentline
        m.commentline = SUBSTR(m.commentline,1,AT(m_delimiter,m.commentline)-1)
    ENDIF
    IF !EMPTY(m.commentline)
        m.commentline = STRTRAN(m.commentline,CHR(13)," ")
        m.commentline = STRTRAN(m.commentline,CHR(10)," ")
        IF LEN(m.commentline) > 100
          m.commentline = SUBSTR(m.commentline,1,100)
        ENDIF   
        \ECHO  <<m.commentline>> > COMMRESP.
    ENDIF
 ELSE
        m.commentline = ALLTRIM(m.groupcomm)
        m.commentline = STRTRAN(m.commentline,CHR(13)," ")
        m.commentline = STRTRAN(m.commentline,CHR(10)," ")
        IF LEN(m.commentline) > 100
           m.commentline = SUBSTR(m.commentline,1,100)
        ENDIF   
        \ECHO  <<m.commentline>> > COMMRESP.
 ENDIF
ENDIF
RETURN(m.commentline)

* Dispaly module history
FUNCTION vhistory
  PARAMETERS filename
  filename = SUBSTR(filename,RAT("\",filename)+1)
  m.history = STRTRAN(m_history,"{FILE}",filename)
  RETURN(m.history) 


* Dispaly module history
FUNCTION VCHKVER
  PARAMETERS filename
  filename = SUBSTR(filename,RAT("\",filename)+1)
  m.history = STRTRAN(m_history,"{FILE}",filename)
  RETURN(m.history) 

* Dispaly module version
FUNCTION vversion
  PARAMETERS filename
  filename = SUBSTR(filename,RAT("\",filename)+1)
  m.history = STRTRAN(m_history,"{FILE}",filename)
  RETURN(m.history) 

* Display module status 
FUNCTION vstatus
  PARAMETERS filename
  filename = SUBSTR(filename,RAT("\",filename)+1)
  m.status = STRTRAN(m_status,"{FILE}",filename)
  RETURN(m.status) 

* PROCEDURES *************
PROCEDURE ShareFiles
* Makes the specified file a member of a current project
PARAMETERS m.project,m.firstname,m.secname,m.cdxname
SET TEXT ON
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\<<SUBSTR(m.path,1,2)>>
\CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
\ECHO **<<m.path+m.firstname>> >><<cWorkFilDir+"chkerr.err">> 
\<<SHAREMODE(m.firstname,m.project)>> >><<cWorkFilDir+"chkerr.err">>          
IF !EMPTY(m.secname)
        \ECHO **<<m.path+m.secname>> >><<cWorkFilDir+"chkerr.err">>
        \<<SHAREMODE(m.secname,m.project)>> >><<cWorkFilDir+"chkerr.err">>             
ENDIF !EMPTY(m.secname)
IF !EMPTY(m.cdxname)
        \ECHO **<<m.path+m.cdxname>> >><<cWorkFilDir+"chkerr.err">>
        \<<SHAREMODE(m.cdxname,m.project)>> >><<cWorkFilDir+"chkerr.err">>               
ENDIF !EMPTY(m.cdxname)

PROCEDURE ShareModule

IF m_host = 0
   * Make a file a member of the current project
   SELE db_pjhd
   SET ORDER TO fullname
   LOCATE FOR  ;
      projdir = m.projdir .AND.  projname=m.projname;
      .AND. !DELETED()
      IF FOUND()
          PRIVATE cDir,cFull,m.firstname,m.secname,m.cdxname
          cDir = sys(5)+curdir()
          =SETDIR(ALLTRIM(db_proje->projdir))
          *SET DEFA TO ALLTRIM(db_proje->projdir)
          cFull  = FULLPATH(project.name)
          m.path = SUBSTR(cFull,1,RAT("\",cFull))
          =SETDIR(cDir)
          *SET DEFA TO (cDir)
          m.firstname = UPPER(ALLTRIM(SUBSTR(m.name,RAT("\",m.name)+1)))
          lastchar = SUBSTR(m.firstname,LEN(m.firstname),1)
          IF ASC(lastchar)= 0
              m.firstname = SUBSTR(m.firstname,1,LEN(m.firstname)-1)
          ENDIF   
          m.secname = SECFILE(m.firstname,m.path) 
          m.cdxname = CDXFILE(m.firstname,m.path)
          =ShareFiles( ALLTRIM(db_pjhd.projname)+mainprojid,;
              m.firstname, m.secname,m.cdxname)
          IF ".DBF" $ m.firstname
             =ShareFiles( ALLTRIM(db_pjhd.projname)+mainprojid,;
               STRTRAN(m.firstname,".DBF",".STR"),"","")
          ENDIF       
       ELSE
           WAIT WINDOW "Project "+ALLTRIM(cProjname)+;
                       "not found in the DB_PJHD" NOWAIT
       ENDIF
ENDIF

PROCEDURE CheIn
* Create batch file to check in  modules
PARAMETERS m.path,m.firstname,m.secname,m.cdxname,cFirst
PRIVATE m.comments
SET TEXT ON
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
IF cFirst
  \<<SUBSTR(m.path,1,2)>>
  \CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
  \ECHO **<<m.path+m.firstname>> >><<cWorkFilDir+"chkerr.err">>
  \<<ADDNEW(m.path+m.firstname)>> >><<cWorkFilDir+"chkerr.err">>            
  *\if errorlevel 100 ECHO Could not run successfully. >> <<cWorkFilDir+"chkerr.err">>    
  IF !EMPTY(m.secname)
       \ECHO **<<m.path+m.secname>> >><<cWorkFilDir+"chkerr.err">>
       \<<ADDNEW(m.path+m.secname)>> >><<cWorkFilDir+"chkerr.err">>            
       \if errorlevel 100 ECHO Could not run successfully. >> <<cWorkFilDir+"chkerr.err">>    
  ENDIF
  IF !EMPTY(m.cdxname)
       \ECHO **<< m.path+m.cdxname >> >><<cWorkFilDir+"chkerr.err">>
       \<<ADDNEW(m.path+m.cdxname)>> >> <<cWorkFilDir+"chkerr.err">>          
       \if errorlevel 100 ECHO Could not run successfully. >> <<cWorkFilDir+"chkerr.err">>    
  ENDIF
ELSE
  m.comments=SETRESP()
  \<<SUBSTR(m.path,1,2)>>
  \CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
  \<<SUBSTR(m.path,1,2)>>
  \ECHO **<<m.path+m.firstname>> >><<cWorkFilDir+"chkerr.err">>
  IF !EMPTY(m.comments)
     \<<CHECKIN(m.firstname)>> -C@<<cWorkFilDir+"COMMRESP.">> >><<cWorkFilDir+"chkerr.err">>           
  ELSE
     \<<CHECKIN(m.firstname)>> -C- >><<cWorkFilDir+"chkerr.err">>           
  ENDIF
  \if errorlevel 100 ECHO Could not run successfully. >> <<cWorkFilDir+"chkerr.err">>    
  IF !EMPTY(m.secname)
       \ECHO **<<m.path+m.secname>> >><<cWorkFilDir+"chkerr.err">>
       \<<CHECKIN(m.secname)>> -C- >><<cWorkFilDir+"chkerr.err">>           
       \if errorlevel 100 ECHO Could not run successfully. >> <<cWorkFilDir+"chkerr.err">>    
  ENDIF
  IF !EMPTY(m.cdxname)
       \ECHO **<< m.path+m.cdxname >> >><<cWorkFilDir+"chkerr.err">>
       \<<CHECKIN(m.cdxname)>>  -C- >><<cWorkFilDir+"chkerr.err">>            
       \if errorlevel 100 ECHO Could not run successfully. >> <<cWorkFilDir+"chkerr.err">>    
  ENDIF
ENDIF

* Create batch file to check in  modules and lock
PROCEDURE CheInLock
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
PRIVATE m.comments
SET TEXT ON
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
  \<<SUBSTR(m.path,1,2)>>
  \CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
  \<<SUBSTR(m.path,1,2)>>
  \<<ADDNEW(m.path+m.firstname)>>           
  \<<CHECKOUT(m.firstname)>>       
  \<<checkinlock(m.firstname)>> -C-            
  IF !EMPTY(m.secname)
       \<<ADDNEW(m.path+m.secname)>>          
       \<<CHECKOUT(m.secname)>>      
       \<<checkinlock(m.secname)>> -C-            
  ENDIF
  IF !EMPTY(m.cdxname)
       \<<ADDNEW(m.path+m.cdxname)>>        
       \<<CHECKOUT(m.cdxname)>>           
       \<<checkinlock(m.cdxname)>>  -C-             
  ENDIF
  \<<SUBSTR(cWorkFilDir,1,2)>>
  \CD <<SUBSTR(cWorkFilDir,1,LEN(ALLTRIM(cWorkFilDir))-1)>>



FUNCTION CheckVersion
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
    \ECHO **<<m.path+m.firstname>> >> STATUS.TXT
    \ECHO <<m.path+m.firstname>> > FILERESP.
    \<<VCHKVER(m.path+m.firstname)>> >> STATUS.TXT
    IF !EMPTY(m.secname) .AND. ;
      FILE(m.path+m.secname ))
      \ECHO **<<m.path+m.secname )>> >> STATUS.TXT
      \ECHO <<m.path+m.secname )>> > FILERESP.
      \<<VCHKVER(m.path+m.secname ))>> >> STATUS.TXT
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
      FILE(m.path+m.cdxname ))
      \ECHO **<<m.path+m.secname )>> >> STATUS.TXT
      \ECHO <<m.path+m.cdxname )>> > FILERESP.
      \<<VCHKVER(m.path+m.cdxname ))>> >> STATUS.TXT
    ENDIF

PROCEDURE CheOut
* Create batch file to check out modules
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
SET TEXT ON
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\<<SUBSTR(m.path,1,2)>>
\CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
\ECHO **<<m.path+m.firstname>> >><<cWorkFilDir+"chkerr.err">> 
\<<CHECKOUT(m.firstname)>> -O<<cWorkFilDir+"chkerr.err">>          
\if errorlevel 100 ECHO Could not run successfully. >> <<cWorkFilDir+"chkerr.err">>    
IF !EMPTY(m.secname)
        \ECHO **<<m.path+m.secname>> >><<cWorkFilDir+"chkerr.err">>
        \<<CHECKOUT(m.secname)>> -O<<cWorkFilDir+"chkerr.err">>             
       \if errorlevel 100 ECHO Could not run successfully. >> <<cWorkFilDir+"chkerr.err">>    
ENDIF !EMPTY(m.secname)
IF !EMPTY(m.cdxname)
        \ECHO **<<m.path+m.cdxname>> >><<cWorkFilDir+"chkerr.err">>
        \<<CHECKOUT(m.cdxname)>> -O<<cWorkFilDir+"chkerr.err">>               
        \if errorlevel 100 ECHO Could not run successfully. >> <<cWorkFilDir+"chkerr.err">>    
ENDIF !EMPTY(m.cdxname)


* Create batch file to check out non-terminal version
PROCEDURE CheOutNt
PARAMETERS m.path,m.firstname,m.secname,m.cdxname,cMode
SET TEXT ON
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\<<RESTORE(m.path+m.firstname)>> 
IF cMode = 'View'
  \COPY <<m.TempLoc+m.firstname>> <<m.TempLoc+m.tFirstname>>
  \ERASE <<m.TempLoc+m.firstname>>
ELSE
  \COPY <<m.firstname>> <<m.TempLoc+m.Firstname>>
  \ERASE <<m.firstname>>
ENDIF
IF !EMPTY(m.secname)
        \<<RESTORE(m.path+m.secname)>> 
        IF cMode = "View"
          \COPY <<m.TempLoc+m.secname>> <<m.TempLoc+m.tSecname>>
          \ERASE <<m.TempLoc+m.secname>>
        ELSE
          \COPY <<m.secname>> <<m.TempLoc+m.Secname>>
          \ERASE <<m.secname>>
        ENDIF
ENDIF !EMPTY(m.secname)
IF !EMPTY(m.cdxname)
        \<<RESTORE(m.path+m.cdxname)>> 
        IF cMode = "View"
          \COPY <<m.TempLoc+m.cdxname>> <<m.TempLoc+m.tCdxname>>
          \ERASE <<m.TempLoc+m.cdxname>>
        ELSE
          \COPY <<m.cdxname>> <<m.TempLoc+m.cdxname>>
          \ERASE <<m.cdxname>>
        ENDIF
 ENDIF !EMPTY(m.cdxname)


PROCEDURE RemoveModule
PARAMETERS m.firstname
IF m_host = 0
    PRIVATE nArea, cOrder
    nArea = SELECT()
    newyes = .T.
    SELE projdata
    cOrder = ORDER()
    SET ORDER TO name
    IF SEEK(m.firstname)
       m.fullname = fullname
       m.path = SUBSTR(m.fullname,1,RAT("\",m.fullname))
       m.secname = SECFILE(m.firstname,m.path,.f.) 
       m.cdxname = CDXFILE(m.firstname,m.path,.f.)
       =RemovePurge(m.firstname,m.secname,m.cdxname)
      IF ".CDX" $ m.firstname
          =RemovePurge(STRTRAN(m.firstname,".DBF",".STR"),"","")
      ENDIF
    ENDIF
    SELE projdata
    SET ORDER TO (cOrder)
    SELE (nArea)
ENDIF     




PROCEDURE RemovePurge 
* Remove files from the project and permanently delete from project
PARAMETERS m.firstname,m.secname,m.cdxname
SET TEXT ON
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\ECHO **<<m.path+m.firstname>> >><<cWorkFilDir+"chkerr.err">> 
\<<RemoveFile(m.firstname)>> >><<cWorkFilDir+"chkerr.err">>          
\<<PurgeFile(m.firstname) >> >><<cWorkFilDir+"chkerr.err">>          
IF !EMPTY(m.secname)
        \ECHO **<<m.path+m.secname>> >><<cWorkFilDir+"chkerr.err">>
        \<<RemoveFile(m.secname)>> >><<cWorkFilDir+"chkerr.err">>             
        \<<PurgeFile(m.secname) >> >><<cWorkFilDir+"chkerr.err">>             
ENDIF !EMPTY(m.secname)
IF !EMPTY(m.cdxname)
        \ECHO **<<m.path+m.cdxname>> >><<cWorkFilDir+"chkerr.err">>
        \<<RemoveFile(m.cdxname)>> >><<cWorkFilDir+"chkerr.err">>             
        \<<PurgeFile(m.cdxname) >> >><<cWorkFilDir+"chkerr.err">>               
ENDIF !EMPTY(m.cdxname)


PROCEDURE DefStatus
    PRIVATE cArea, cFilext 
    SET TEXT ON
    SET TEXT TO (cWorkFilDir+"STATUS.TXT")  ADDITIVE NOSHOW
    \
    SET TEXT TO (cWorkFilDir+"STATUSC.BAT") ADDITIVE NOSHOW
    SET PROC TO (home_dir+"FPROC.PRG")
    cArea = SELECT()
    cFilext   = ALLTRIM(UPPER(SUBSTR(name,AT(".",name)+1)))
    IF cFilext = "DBF" .AND. controlled = 'Str'
         cFilext = "STR"
    ENDIF     
    =OPENDBF("DB_PJFL","DB_PJFL")
    SET ORDER TO extension
    IF SEEK(cFilext)
       m.secname = secname
       m.cdxname = cdxname
    ELSE
       m.secname = ""
       m.cdxname = ""
    ENDIF       
    SELECT (cArea)
    \ECHO ********************** > STATUS.TXT
    \ECHO <<cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext>> > FILERESP.
    \<<VSTATUS(cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext)>> -O@status.txt
    IF !EMPTY(m.secname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname )))
       \ECHO ********************** >> STATUS.TXT
       \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))>> > FILERESP.
       \<<VSTATUS(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname )))>> -O@status.txt
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
       \ECHO ********************** >> STATUS.TXT
       \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname )>> > FILERESP.
       \<<VSTATUS(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))>> -O@status.txt
    ENDIF
  \
  SELECT (cArea)
RETURN (.T.)


 
PROCEDURE DefHistory
    PRIVATE m.fullname,m.secname, m.cdxname, m.descrip
    SET TEXT ON
    SET TEXT TO (cWorkFilDir+"HISTORYC.BAT") ADDITIVE NOSHOW
    SET PROC TO (home_dir+"FPROC.PRG")
    cArea = SELECT()
    cFilext   = ALLTRIM(UPPER(SUBSTR(name,AT(".",name)+1)))
    IF cFilext = "DBF" .AND. controlled = 'Str'
         cFilext = "STR"
    ENDIF     
    =OPENDBF("DB_PJFL","DB_PJFL")
    SET ORDER TO extension
    IF SEEK(cFilext)
       m.secname = secname
       m.cdxname = cdxname
       m.descrip = ALLTRIM(descrip)
    ELSE
       m.secname = ""
       m.cdxname = ""
       m.descrip = ""
    ENDIF       
	  m.fullname = upper( cFileDir+name )
	  m.fullname = SUBSTR(m.fullname,1,RAT(".",m.fullname)-1)
    cWinTitle  = "History for "+m.descrip  +" "+m.fullname
    SELECT (cArea)
    \ECHO ********************** > HISTORY.TXT
    \ECHO <<cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext>> > FILERESP.
    \<<VHISTORY(cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext)>> -O@history.txt
    IF !EMPTY(m.secname) .AND. ;
      FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
      \ECHO ********************** >> HISTORY.TXT
      \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname )>> > FILERESP.
      \<<VHISTORY(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))>> -O@history.txt

    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
      FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
      \ECHO ********************** >> HISTORY.TXT
      \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname )>> > FILERESP.
      \<<VHISTORY(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))>> -O@history.txt

    ENDIF
  \

RETURN (.T.)

FUNCTION CheckModVersion
PARAMETERS cFullname
\ECHO **:<<cFullname>> >> STATUS.TXT
\ECHO <<cFullname>> > FILERESP.
\<<VCHKVER(cFullname)>> -O@STATUS.TXT


FUNCTION CheckVersion
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
    \ECHO **<<m.path+m.firstname>> >> STATUS.TXT
    \ECHO <<m.path+m.firstname>> > FILERESP.
    \<<VCHKVER(m.path+m.firstname)>> -O@STATUS.TXT
    IF !EMPTY(m.secname) .AND. ;
      FILE(m.path+m.secname ))
      \ECHO **<<m.path+m.secname )>> >> STATUS.TXT
      \ECHO <<m.path+m.secname )>> > FILERESP.
      \<<VCHKVER(m.path+m.secname ))>>  -O@STATUS.TXT
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
      FILE(m.path+m.cdxname ))
      \ECHO **<<m.path+m.secname )>> >> STATUS.TXT
      \ECHO <<m.path+m.cdxname )>> > FILERESP.
      \<<VCHKVER(m.path+m.cdxname ))>>  -O@STATUS.TXT
    ENDIF

* Refresh from Local directory
PROCEDURE rfrhost
RETURN (.T.)



* Create VC.CFG and make STORE directory
PROCEDURE CreaAll
PARAMETERS m.projname,m.projdir
RETURN (.T.)




******
* Test reading of Error File from Checkin/Checkout:
* 02/03/93  (rg)
*    If you remove "*" from delete command after "if lOk"
*    statement, it will delete records for successful entries
*    leaving only the errors (I think this is better...).
*    Note that there can be 1 OR 2 records for an error.
*    We should leave both.
*
* Current directory - cSpecFilDir
*
procedure checktst
private nModRecNo, nCurRec, cModName, lOk, lDone, lFirst,oldarea,wtop
curarea = SELECT()

SELE 0
create table (cWorkFilDir+"chkerr") ( Result C(100) , ;
                      Module C(50) , ;
                      IsError L )


if file( cWorkFilDir+"CHKERR.DBF" )
  use (cWorkFilDir+"CHKERR") excl
  zap
  append from CHKERR.ERR SDF
  *DELETE FILE CHKERR.ERR
  IF RECCOUNT() = 0
     RETURN
  ENDIF   
  go top
  lDone = .F.
  lFirst = .T.
  nModRecNo = recno()  && starting record number
  cModName  = substr( Result, 3 )
  
   lOk = .T.  && indicator that operation was successful
  do while !lDone
    lDone = eof()
    if !lFirst and ( substr( Result, 1, 2 ) = "**" or eof() )
      nCurRec = min( recno(), reccount() )
      goto nModRecNo
      delete   && we don't need "**" indicator record any more...
      do while ( recno() < nCurRec or nCurRec = reccount() ) and !eof()
        replace module with cModName
        replace IsError with !lOK
        if lOk  &&  delete references to OK operations
          * delete  && temporary block for testing
        endif
        skip
      enddo
      goto nCurRec
      nModRecNo = recno()  && starting record number
      cModName  = substr( Result, 3 )
      *lOk = .F.
      lOk = .T.
    else
      IF not "**" $ Result 
        if ALLTRIM(Result) $ UPPER(cModName)
          DO WHILE NOT ("**" $ result .OR. eof())
             SKIP
          ENDDO  
          LOOP
        ENDIF
        if "same as" $ Result or ;
          ("checked out" $ result and not "already" $ Result  ;
          and not "do not have" $ Result) or ;
          ( "created" $ Result and not "not" $ Result ) or ;
          "extracted" $ Result or "updated" $ Result or ;
          "checked out by " + trim( m_userid ) $ Result or ;
          "created" $ Result .or. "unlocked" $ Result ;
          .OR. ALLTRIM(Result) $ cModName 
           *lOk = .T.
        else 
           lOk = .f.
        endif
      ENDIF
    endif
    lFirst = .F.
    skip
  enddo
  pack
else
  wait "Error Opening Checkin/out Error File!" window
endif
SELECT *;
  FROM CHKERR;  
  WHERE IsError;
  INTO CURSOR temperr
  SELECT (curarea)
IF USED("chkerr")
  USE IN chkerr
ENDIF
return


FUNCTION vcstr
* Indicate that module is not a controlled
RETURN("not an existing filename or project")

FUNCTION runbatch
* Run batch file
PARAMETERS filename
IF TYPE("m_ace") = 'U'
  PUBLIC m_ace
  m_ace = .f.
ENDIF
IF m_ace
   DO ase WITH filename
ELSE
   !&filename
   =SETDIR(home_dir)
   IF _DOS
     ACTI SCREEN
     set color to (m_background)
     @ 0,0,srows(),scols() box '        '+m_character
     DO sysmes
     SET COLOR TO
   ENDIF
ENDIF
=SETDIR(home_dir)

FUNCTION vertrack  
* Create version list
PRIVATE cName, ans,cMemo,nArea, nStart, nEnd, lFirstTime, cComment   
PRIVATE nPos, nPos1, cVer, cUserid, cDateTime, cLine, cAns, cDate, cTime

cMemo = SET("MEMO")
SET MEMO TO 100

SELE 0
CREATE CURSOR VERHIST ;
( VERSION C(5), DATE_IN D, TIME_IN C(8), USERID C(12), COMMENT C(130) )

SELE 0
CREATE CURSOR TempMemo ( temp M)
APPEND BLANK
APPEND MEMO temp FROM HISTORY.TXT

nStart  = atcline(m.firstname, temp)
IF !EMPTY(m.secname)
  nEnd    = atcline(m.secname ,temp)-2
ELSE
  nEnd    = MEMLINES(temp)
ENDIF

lComment = .F.
m.comment = ""
WAIT WINDOW "Creating version database..." NOWAIT 

FOR i = nStart TO nEnd
  ans   = MLINE(temp,i)
  DO CASE
    CASE "Version" $ ans
       * Beginning of new record
       IF lComment
         * End of record
         INSERT INTO VERHIST FROM MEMVAR
         m.comment = ""
       ENDIF
       lComment = .F.
       nPos1 = AT("Version",ans)+8
       cAns  = SUBSTR(ans,nPos1)
       nPos2 = AT("*",cAns)
       m.version  = ALLTRIM(SUBSTR(cAns,1,nPos2-1))
    CASE "User:" $ ans
       nPos1 = AT("User:",ans)+5
       nPos2 = AT("Date:",ans)
       * User ID
       m.userid   = ALLTRIM(SUBSTR(ans,nPos1,nPos2-Npos1-1))
       * Time module was checked out
       m.cDatetime = ALLTRIM(SUBSTR(ans,nPos2))
       m.cDatetime =STRTRAN(m.cDatetime,"Date:","")
       m.cDatetime =ALLTRIM(STRTRAN(m.cDatetime,"Time:",""))
       nPos1 = AT(" ",m.cDatetime)
       m.date_in = CTOD(ALLTRIM(SUBSTR(m.cDatetime,1,nPos1-1)))
       m.time_in = ALLTRIM(SUBSTR(m.cDatetime,nPos1))
       *m.cDatetime = cDate+", "+cTime
    CASE "Comment:" $ ans
       lComment = .t.
       m.comment = m.comment+ALLTRIM(STRTRAN(ans,"Comment:",""))
    OTHERWISE
       IF lComment
           m.comment = m.comment+ALLTRIM(ans)
       ENDIF
  ENDCASE
ENDFOR
* End of file
INSERT INTO VERHIST FROM MEMVAR

SELE VERHIST
WAIT CLEAR
SET MEMO TO (cMemo)
RETURN


FUNCTION UpdateTempCursor
PRIVATE m.name, nLine, ans,nArea
PRIVATE nSpace1,nSpace2,nSpace3,nSpace4,nSpace5,nPos, nPos1, nPos2
PRIVATE m.year, m.month, m.day 
PRIVATE cName, ans,cMemo,nArea, nStart, nEnd, lFirstTime, cComment   
PRIVATE nPos, nPos1, cVer, cUserid, cDateTime, cLine, cAns, cDate, cTime
nArea = SELECT()
m.fullname =  ALLTRIM(fullname)
IF ".STR" $ UPPER(module)
  m.fullname = STRTRAN(m.fullname,".DBF",".STR")
ENDIF  

SELE headers
SET ORDER TO name
IF NOT SEEK("**"+m.fullname)
   SET ORDER TO
   SELECT (nArea)
   RETURN (.T.)
ENDIF   
SET ORDER TO
SKIP

IF NOT "Version" $ name
      SKIP -1
      m.nRecno = headers.nrecno 
      SELE tempstat
      GOTO m.nRecno
      SKIP
      m.error = name  
      SELECT (nArea)
      RETURN
ENDIF

IF !EOF()
  m.nRecno = headers.nrecno 
  SELE tempstat
  GOTO m.nRecno
  * Beggining of the version record
  ans = ALLTRIM(name)
  nPos1 = AT("Version",ans)+8
  cAns  = SUBSTR(ans,nPos1)
  nPos2 = AT("*",cAns)
  m.version  = ALLTRIM(SUBSTR(cAns,1,nPos2-1))
  DO WHILE NOT "User" $ name    
      SKIP
  ENDDO  
ELSE
  SELE tempstat
  GOTO BOTTOM
ENDIF

ans = ALLTRIM(name)

nPos1 = AT("User:",ans)+5
nPos2 = AT("Date:",ans)
m.userid   = ALLTRIM(SUBSTR(ans,nPos1,nPos2-Npos1-1))
m.cDatetime = ALLTRIM(SUBSTR(ans,nPos2))
m.cDatetime =STRTRAN(m.cDatetime,"Date:","")
m.cDatetime =ALLTRIM(STRTRAN(m.cDatetime,"Time:",""))
nPos1 = AT(" ",m.cDatetime)
m.date = CTOD(ALLTRIM(SUBSTR(m.cDatetime,1,nPos1-1)))
m.time = ALLTRIM(SUBSTR(m.cDatetime,nPos1))
SELECT (nArea)
RETURN (.T.)

FUNCTION CreateVers
* Create version table from Source Sage
PRIVATE nArea
nArea = SELECT()

   SELE 0
   CREATE CURSOR versions; 
   (FULLNAME C(100), VERSION C(20), ;
       DATE_IN D, TIME_IN C(8), DATE_MOD D, TIME_MOD C(8), ;
       USERID C(12) )
   INDEX ON fullname TAG fullname
   SELE MainFiles
   * Now proceed other modules
   SCAN
      m.module = ALLTRIM(module)
      SELE AllFiles
      SCAN FOR module = m.module 
        SET PROC TO (home_dir+m_specproc)
        =CheckModVersion(ALLTRIM(fullname))
        SET PROC TO FPROC
      ENDSCAN
   ENDSCAN
   SET PROC TO FPROC
   SET TEXT TO 
   SET TEXT OFF
   ACTI SCREEN
   =SETDIR(cWorkFilDir)
   DO runbat WITH "setall"
   =SETDIR(cWorkFilDir)
   IF m_erasebat
     DELETE FILE "SETALL.BAT"
     DELETE FILE CHKERR.ERR 
   ENDIF

 SELE 0
 CREATE CURSOR tempstat ;
  ( name C(100) )

 IF FILE("STATUS.TXT")
    append from STATUS.TXT SDF
 ENDIF


 SELECT name;
   FROM tempstat;
   WHERE "**:" $ name;
  .OR. "Version" $ name;
  .OR. "User" $ name;
  INTO CURSOR AllVersions

 SCAN
   DO CASE
     CASE "**:" $ name
       m.fullname = SUBSTR(name,4)
     CASE "Version" $ name
       * Beginning of new record
       nPos1 = AT("Version",name)+8
       cname  = SUBSTR(name,nPos1)
       nPos2 = AT("*",cname)
       m.version  = ALLTRIM(SUBSTR(cname,1,nPos2-1))
    CASE "User:" $ name
       nPos1 = AT("User:",name)+5
       nPos2 = AT("Date:",name)
       * User ID
       m.userid   = ALLTRIM(SUBSTR(name,nPos1,nPos2-Npos1-1))
       * Time module was checked out
       m.cDatetime = ALLTRIM(SUBSTR(name,nPos2))
       m.cDatetime =STRTRAN(m.cDatetime,"Date:","")
       m.cDatetime =ALLTRIM(STRTRAN(m.cDatetime,"Time:",""))
       nPos1 = AT(" ",m.cDatetime)
       m.date_in = CTOD(ALLTRIM(SUBSTR(m.cDatetime,1,nPos1-1)))
       m.time_in = ALLTRIM(SUBSTR(m.cDatetime,nPos1))
       *m.cDatetime = cDate+", "+cTime
       INSERT INTO versions FROM MEMVAR
       DO WHILE NOT "**:" $ name    
          IF EOF()
             EXIT
          ENDIF  
          SKIP
       ENDDO  
       SKIP -1
    ENDCASE
 ENDSCAN
SELECT (nArea)