**$NOKEYWORDS$
************************************
* Version control commands and functions
* TLIB
************************************
*****************
* User commands
*****************
*Add and remove users
FUNCTION ssadmin
RETURN ( .T. )

***************************
* Projects Commands *
***************************
*Add new project
PROCEDURE ssaddproj
PARAMETERS cProject
RETURN ( .T. )

*Remove project
PROCEDURE ssremproject
PARAMETERS cProject
RETURN ( .T. )

*Select project
PROCEDURE ssseleproject
PARAMETERS cProject
RETURN ( .T. )


*********************************
*Module commands and functions
*********************************

* COMMANDS

* Add New Module command
FUNCTION fAdd
RETURN('TLIB N {FILE} New Module')

* Add New Module and Keep Locked
FUNCTION fAddLocked
RETURN('TLIB NKF {FILE} New Module')

* Remove Module command
FUNCTION fRemove
RETURN('')

FUNCTION fPurge
RETURN('')

FUNCTION fShare
RETURN('')

* Check In command
FUNCTION fCheckin
RETURN ('TLIB U {FILE} {COMMENTS}')

* Check In and Lock 
FUNCTION fChlock
RETURN ('TLIB UK {FILE} {COMMENTS}')

* Check Out command
FUNCTION fCheckout
RETURN('TLIB E {FILE}')

* Restore version command
FUNCTION fRestore
RETURN('TLIB ESB {FILE} {VERSION}')


* History report command
FUNCTION fHistory
RETURN('TLIB L {FILE}')

* History report command for latest version
FUNCTION fcheckver
RETURN('TLIB L {FILE}')

* Status report command
FUNCTION fStatus
RETURN('TLIB T {FILE}')

* FUNCTIONS

* Add and Check In module
FUNCTION AddNew
PARAMETERS filename
PRIVATE m.add
m.add = STRTRAN(fAdd(),"{FILE}",filename)
m.add = STRTRAN(m.add,"{LIBPATH}",StoreDir(filename))
RETURN(ALLTRIM(m.add))

* Add and Keep Locked
FUNCTION AddNewLock
PARAMETERS filename
PRIVATE m.add
m.add = STRTRAN(fAddLocked(),"{FILE}",filename)
m.add = STRTRAN(m.add,"{LIBPATH}",StoreDir(filename))
RETURN(ALLTRIM(m.add))




* Remove file from the project
FUNCTION RemoveFile
PARAMETERS filename
RETURN ( "" )

* Permanently delete a Removed file from the project
FUNCTION PurgeFile
PARAMETERS filename
PRIVATE m.purge
RETURN ( "" )

* Share modules
FUNCTION sharemode
PARAMETERS filename,cProjname
RETURN ( "" )

* Check In module
FUNCTION checkin
PARAMETERS filename
PRIVATE m.checkin
m.checkin = STRTRAN(fCheckin(),"{FILE}","@FILERESP")
m.checkin = STRTRAN(m.checkin,"{COMMENTS}","@COMMRESP")
m.checkin = STRTRAN(m.checkin,"{LIBPATH}",StoreDir(filename))
RETURN(ALLTRIM(m.checkin))

* Check In module and lock
FUNCTION checkinlock
PARAMETERS filename
PRIVATE m.checkin
m.checkin = STRTRAN(fChlock(),"{FILE}","@FILERESP")
m.checkin = STRTRAN(m.checkin,"{COMMENTS}",".")
m.checkin = STRTRAN(m.checkin,"{LIBPATH}",StoreDir(filename))
RETURN(ALLTRIM(m.checkin))


* Check In module without comment
FUNCTION checkinnc
PARAMETERS filename
PRIVATE m.checkin
m.checkin = STRTRAN(fCheckin(),"{FILE}","@FILERESP")
m.checkin = STRTRAN(m.checkin,"{COMMENTS}",".")
m.checkin = STRTRAN(m.checkin,"{LIBPATH}",StoreDir(filename))
RETURN(ALLTRIM(m.checkin))

* Check Out module
FUNCTION checkout
PARAMETERS filename,m.checkout
m.checkout = STRTRAN(fCheckout(),"{FILE}","@FILERESP")
m.checkout = STRTRAN(m.checkout,"{LIBPATH}",StoreDir(filename))
RETURN(m.checkout)


* Restore module
FUNCTION restore
PARAMETERS filename
PRIVATE m.restore
m.restore = STRTRAN(fRestore(),"{FILE}","@FILERESP")
m.restore = STRTRAN(m.restore,"{LIBPATH}",StoreDir(filename))
m.restore = STRTRAN(m.restore,"{VERSION}",cVer)
RETURN(m.restore)

* Dispaly module history
FUNCTION vhistory
  PARAMETERS filename
  * filename = SUBSTR(filename,RAT("\",filename)+1)  && (rg)  09/13/93
  m.history = STRTRAN(fHistory(),"{FILE}",filename)
  m.history = STRTRAN(m.history,"{LIBPATH}",StoreDir(filename))
  RETURN(m.history)

* Dispaly module history
FUNCTION VCHKVER
  PARAMETERS filename
  * filename = SUBSTR(filename,RAT("\",filename)+1)  && (rg)  09/13/93
  m.history = STRTRAN(fcheckver(),"{FILE}",filename)
  m.history = STRTRAN(m.history,"{LIBPATH}",StoreDir(filename))
  RETURN(m.history)

* Dispaly module version
FUNCTION vversion
  PARAMETERS filename
  * filename = SUBSTR(filename,RAT("\",filename)+1)  && (rg)  09/13/93
  m.history = STRTRAN(fVersion(),"{FILE}",filename)
  m.history = STRTRAN(m.history,"{LIBPATH}",StoreDir(filename))
  RETURN(m.history)



* Display module status
FUNCTION vstatus
  PARAMETERS filename
  * filename = SUBSTR(filename,RAT("\",filename)+1)  && (rg)  09/13/93
  m.status = STRTRAN(fStatus(),"{FILE}",filename)
  m.status = STRTRAN(m.status,"{LIBPATH}",StoreDir(filename))
  RETURN(m.status)


* PROCEDURES *************

PROCEDURE DefStatus
    PRIVATE cArea, cFilext, m.path 
    SET TEXT TO (cWorkFilDir+"STATUS.TXT")  ADDITIVE NOSHOW
    \
    SET TEXT TO (cWorkFilDir+"STATUSC.BAT") ADDITIVE NOSHOW
    SET PROC TO (home_dir+"FPROC.PRG")
    cArea = SELECT()
    cFilext   = ALLTRIM(UPPER(SUBSTR(name,AT(".",name)+1)))
    IF cFilext = "DBF" .AND. controlled = 'Str'
         cFilext = "STR"
    ENDIF     
    SET PROC TO FPROC
    =OPENDBF("DB_PJFL","DB_PJFL")
    SET ORDER TO extension
    IF SEEK(cFilext)
       m.secname = secname
       m.cdxname = cdxname
    ELSE
       m.secname = ""
       m.cdxname = ""
    ENDIF       
    SELECT (cArea)
    \<<SUBSTR(cFileDir,1,2)>>
    \CD <<SUBSTR(cFileDir,1,LEN(ALLTRIM(cFileDir))-1)>>
    \ECHO ********************** > <<cWorkFilDir+"STATUS.TXT">>
    \ECHO <<cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext>> > FILERESP.
    \<<VSTATUS(cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext)>> >><<cWorkFilDir+"STATUS.TXT">>
    IF !EMPTY(m.secname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname )))
       \ECHO ********************** >> <<cWorkFilDir+"STATUS.TXT">>
       \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))>> > FILERESP.
       \<<VSTATUS(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname )))>> >><<cWorkFilDir+"STATUS.TXT">>
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
       \ECHO ********************** >> <<cWorkFilDir+"STATUS.TXT">>
       \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname )>> > FILERESP.
       \<<VSTATUS(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))>> >><<cWorkFilDir+"STATUS.TXT">>
    ENDIF
  \
  SELECT (cArea)
RETURN (.T.)


 
PROCEDURE DefHistory
    PRIVATE m.fullname, m.firstname, m.secname, m.cdxname, cArea, m.descrip
    SET TEXT ON
    SET TEXT TO (cWorkFilDir+"HISTORYC.BAT") ADDITIVE NOSHOW
    SET PROC TO (home_dir+"FPROC.PRG")
    cArea = SELECT()
    cFilext   = ALLTRIM(UPPER(SUBSTR(name,AT(".",name)+1)))
    IF TYPE("controlled") <> "U" .AND. cFilext = "DBF" ;
        .AND. controlled = 'Str'
         cFilext = "STR"
    ENDIF     
    SET PROC TO FPROC
    =OPENDBF("DB_PJFL","DB_PJFL")
    SET ORDER TO extension
    IF SEEK(cFilext)
       m.secname = secname
       m.cdxname = cdxname
       m.descrip = ALLTRIM(descrip)
    ELSE
       m.secname = ""
       m.cdxname = ""
       m.descrip = ""
    ENDIF       
	  m.fullname = upper( cFileDir+name )
	  m.fullname = SUBSTR(m.fullname,1,RAT(".",m.fullname)-1)
    cWinTitle  = "History for "+m.descrip  +" "+m.fullname
    SELECT (cArea)
    \<<SUBSTR(cFileDir,1,2)>>
    \CD <<SUBSTR(cFileDir,1,LEN(ALLTRIM(cFileDir))-1)>>
    \ECHO ********************** > <<cWorkFilDir+"HISTORY.TXT">>
    \ECHO <<cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext>> > FILERESP.
    \<<VHISTORY(cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext)>> >><<cWorkFilDir+"HISTORY.TXT">>
    IF !EMPTY(m.secname) .AND. ;
      FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
      \ECHO ********************** >> <<cWorkFilDir+"HISTORY.TXT">>
      \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname )>> > FILERESP.
      \<<VHISTORY(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))>> >><<cWorkFilDir+"HISTORY.TXT">>
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
      FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
      \ECHO ********************** >> <<cWorkFilDir+"HISTORY.TXT">>
      \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname )>> > FILERESP.
      \<<VHISTORY(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))>> >><<cWorkFilDir+"HISTORY.TXT">>
    ENDIF
  \

RETURN (.T.)


FUNCTION CheckVersion
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
    \<<SUBSTR(m.path,1,2)>>
    \CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
    \ECHO **<<m.path+m.firstname>> >> <<cWorkFilDir+"STATUS.TXT">>
    \ECHO <<m.path+m.firstname>> > FILERESP.
    \<<VCHKVER(m.path+m.firstname)>> >> <<cWorkFilDir+"STATUS.TXT">>
    IF !EMPTY(m.secname) .AND. ;
      FILE(m.path+m.secname ))
      \ECHO **<<m.path+m.secname )>> >> <<cWorkFilDir+"STATUS.TXT">>
      \ECHO <<m.path+m.secname )>> > FILERESP.
      \<<VCHKVER(m.path+m.secname ))>> >> <<cWorkFilDir+"STATUS.TXT">>
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
      FILE(m.path+m.cdxname ))
      \ECHO **<<m.path+m.secname )>> >> <<cWorkFilDir+"STATUS.TXT">>
      \ECHO <<m.path+m.cdxname )>> > FILERESP.
      \<<VCHKVER(m.path+m.cdxname ))>> >> <<cWorkFilDir+"STATUS.TXT">>
    ENDIF



PROCEDURE ShareFiles
PARAMETERS m.project,m.firstname,m.secname,m.cdxname
RETURN (.T.)

PROCEDURE ShareModule
RETURN (.T.)

* Create batch file to check in  modules
PROCEDURE CheIn
PARAMETERS m.path,m.firstname,m.secname,m.cdxname,cFirst
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\<<SUBSTR(m.path,1,2)>>
\CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
IF cFirst
  \ECHO **<<m.path+m.firstname>> >><<cWorkFilDir+"CHKERR.ERR">>
  m.comments=SETRESP()
  \ECHO <<m.path+m.firstname>> > FILERESP.
  \<<AddNew(m.path+m.firstname)>>  >><<cWorkFilDir+"CHKERR.ERR">>
  IF !EMPTY(m.secname)
         \ECHO **<<m.path+m.secname>> >><<cWorkFilDir+"CHKERR.ERR">>
         \ECHO <<m.path+m.secname>> > FILERESP.
         \<<AddNew(m.path+m.secname)>> >><<cWorkFilDir+"CHKERR.ERR">>
  ENDIF
  IF !EMPTY(m.cdxname)
         \ECHO **<< m.path+m.cdxname >> >><<cWorkFilDir+"CHKERR.ERR">>
         \ECHO <<m.path+m.cdxname>> > FILERESP.
         \<<AddNew(m.path+m.cdxname)>>  >><<cWorkFilDir+"CHKERR.ERR">>
  ENDIF
Else
  m.comments=SETRESP()
  \ECHO **<<m.path+m.firstname>> >><<cWorkFilDir+"CHKERR.ERR">>
  \ECHO <<m.path+m.firstname>> > FILERESP.
  \<<CHECKIN(m.path+m.firstname)>>  >><<cWorkFilDir+"CHKERR.ERR">>
  IF !EMPTY(m.secname)
         \ECHO **<<m.path+m.secname>> >><<cWorkFilDir+"CHKERR.ERR">>
         \ECHO <<m.path+m.secname>> > FILERESP.
         \<<CHECKINNC(m.path+m.secname)>> >><<cWorkFilDir+"CHKERR.ERR">>
  ENDIF
  IF !EMPTY(m.cdxname)
         \ECHO **<< m.path+m.cdxname >> >><<cWorkFilDir+"CHKERR.ERR">>
         \ECHO <<m.path+m.cdxname>> > FILERESP.
         \<<CHECKINNC(m.path+m.cdxname)>>  >><<cWorkFilDir+"CHKERR.ERR">>
  ENDIF
ENDIF


* Create batch file to check in  modules
PROCEDURE CheInLock
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
  \<<SUBSTR(m.path,1,2)>>
  \CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
  \ECHO **<<m.path+m.firstname>> >><<cWorkFilDir+"CHKERR.ERR">>
  m.comments=SETRESP()
  \ECHO <<m.path+m.firstname>> > FILERESP.
  \<<AddNewLock(m.path+m.firstname)>>  >><<cWorkFilDir+"CHKERR.ERR">>
  \<<CheckinLock(m.path+m.firstname)>>  >><<cWorkFilDir+"CHKERR.ERR">>
  IF !EMPTY(m.secname)
         \ECHO **<<m.path+m.secname>> >><<cWorkFilDir+"CHKERR.ERR">>
         \ECHO <<m.path+m.secname>> > FILERESP.
         \<<AddNewLock(m.path+m.secname)>> >><<cWorkFilDir+"CHKERR.ERR">>
         \<<CheckinLock(m.path+m.secname)>> >><<cWorkFilDir+"CHKERR.ERR">>
  ENDIF
  IF !EMPTY(m.cdxname)
         \ECHO **<< m.path+m.cdxname >> >><<cWorkFilDir+"CHKERR.ERR">>
         \ECHO <<m.path+m.cdxname>> > FILERESP.
         \<<AddNewLock(m.path+m.cdxname)>>  >><<cWorkFilDir+"CHKERR.ERR">>
         \<<CheckinLock(m.path+m.cdxname)>>  >><<cWorkFilDir+"CHKERR.ERR">>
  ENDIF


* Add comment to file for Check In module command
FUNCTION setresp
PRIVATE m.commentline, nArea, lCommCursorYes
lCommCursorYes = .F.
IF USED("comments")
    nArea = SELECT()
    SELE comments
    SET ORDER TO name
    IF SEEK(current.name)
        m.commentline = ALLTRIM(comments.comments)
        m.commentline = STRTRAN(m.commentline,CHR(13)," ")
        m.commentline = STRTRAN(m.commentline,CHR(10)," ")
        IF LEN(m.commentline) > 100
            m.commentline = SUBSTR(m.commentline,1,100)
        ENDIF   
        \ECHO  <<m.commentline>> > COMMRESP.
        lCommCursorYes = .T.
    ENDIF
    SELECT (nArea)
ENDIF
IF NOT lCommCursorYes 
  IF EMPTY(m.groupcomm) .OR. TYPE("m.groupcomm") <> "C"
   IF SUBSTR(comments,1,2) = "**"
     m.commentline = ""  
     \ECHO .> COMMRESP.
   ENDIF
   m.commentline = comments
   IF m_delimiter $ m.commentline
       m.commentline = SUBSTR(m.commentline,1,AT(m_delimiter,m.commentline)-1)
   ENDIF
   IF !EMPTY(m.commentline)
       m.commentline = STRTRAN(m.commentline,CHR(13)," ")
       m.commentline = STRTRAN(m.commentline,CHR(10)," ")
       IF LEN(m.commentline) > 100
          m.commentline = SUBSTR(m.commentline,1,100)
       ENDIF   
       \ECHO  <<m.commentline>> > COMMRESP.
   ELSE  && no blank comments for TLIB.
       \ECHO .> COMMRESP.
   ENDIF
 ELSE
   m.commentline = ALLTRIM(m.groupcomm) 
   m.commentline = STRTRAN(m.commentline,CHR(13)," ")
   m.commentline = STRTRAN(m.commentline,CHR(10)," ")
   IF LEN(m.commentline) > 100
         m.commentline = SUBSTR(m.commentline,1,100)
   ENDIF   
   \ECHO  <<m.commentline>> > COMMRESP.
 ENDIF
ENDIF


RETURN(m.commentline)

* Create batch file to check out modules
PROCEDURE CheOut
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\<<SUBSTR(m.path,1,2)>>
\CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
\ECHO **<<m.path+m.firstname>> >><<cWorkFilDir+"CHKERR.ERR">>
\ECHO <<m.path+m.firstname>> > FILERESP.
\<<CHECKOUT(m.path+m.firstname)>> >><<cWorkFilDir+"CHKERR.ERR">>
IF !EMPTY(m.secname)
        \ECHO **<<m.path+m.secname>> >><<cWorkFilDir+"CHKERR.ERR">>
        \ECHO <<m.path+m.secname>> > FILERESP.
        \<<CHECKOUT(m.path+m.secname)>> >><<cWorkFilDir+"CHKERR.ERR">>
ENDIF !EMPTY(m.secname)
IF !EMPTY(m.cdxname)
        \ECHO **<<m.path+m.cdxname>> >><<cWorkFilDir+"CHKERR.ERR">>
        \ECHO <<m.path+m.cdxname>> > FILERESP.
        \<<CHECKOUT(m.path+m.cdxname)>> >><<cWorkFilDir+"CHKERR.ERR">>
ENDIF !EMPTY(m.cdxname)


* Create batch file to check out non-terminal version
PROCEDURE CheOutNt
PARAMETERS m.path,m.firstname,m.secname,m.cdxname,lMode
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\<<SUBSTR(m.path,1,2)>>
\CD <<SUBSTR(m.path,1,LEN(ALLTRIM(m.path))-1)>>
\ECHO <<m.TempLoc+m.firstname>> > FILERESP.
\<<RESTORE(m.path+m.firstname)>> 
\ATTRIB <<m.TempLoc+m.firstname>> -R
IF lMode = "View"
  \COPY <<m.TempLoc+m.firstname>> <<m.TempLoc+m.tFirstname>>
  \ERASE <<m.TempLoc+m.firstname>>
ENDIF
IF !EMPTY(m.secname)
        \ECHO <<m.TempLoc+m.secname>> > FILERESP.
        \<<RESTORE(m.path+m.secname)>> 
        \ATTRIB <<m.TempLoc+m.secname>> -R
        IF lMode = "View"
          \COPY <<m.TempLoc+m.secname>> <<m.TempLoc+m.tSecname>>
          \ERASE <<m.TempLoc+m.secname>>
        ENDIF
ENDIF !EMPTY(m.secname)
IF !EMPTY(m.cdxname)
        \ECHO <<m.TempLoc+m.cdxname>> > FILERESP.
        \<<RESTORE(m.path+m.cdxname)>> 
        \ATTRIB <<m.TempLoc+m.cdxname>> -R
        IF lMode = "View"
          \COPY <<m.TempLoc+m.cdxname>> <<m.TempLoc+m.tCdxname>>
          \ERASE <<m.TempLoc+m.cdxname>>
        ENDIF
ENDIF !EMPTY(m.cdxname)

* Refresh from Local directory
PROCEDURE rfrhost
RETURN (.T.)

PROCEDURE RemoveModule
PARAMETERS m.firstname
RETURN (.T.)

PROCEDURE RemovePurge
PARAMETERS m.firstname,m.secname,m.cdxname
RETURN (.T.)

* Create STORE directory
PROCEDURE CreaAll
PARAMETERS m.projname, cDir_to_create
PRIVATE cdir
=SETDIR(cDir_to_create)
=MAKEDIR(cDir_to_create+"STORE")   && should depend on db_stat setting. (rg)
=SETDIR(home_dir)
RETURN (.T.)

* Storage Directory
FUNCTION StoreDir
parameter filename
return( SUBSTR(filename,1,RAT("\",filename) ) + "STORE" )

********************************
* Test reading of Error File from Checkin/Checkout:
* 02/03/93  (rg)
*    If you remove "*" from delete command after "if lOk"
*    statement, it will delete records for successful entries
*    leaving only the errors (I think this is better...).
*    Note that there can be 1 OR 2 records for an error.
*    We should leave both.
*
* Current directory - cSpecFilDir
*
procedure checktst
private nModRecNo, nCurRec, cModName, lOk, lDone, lFirst,oldarea,wtop
curarea = SELECT()



create table (cWorkFilDir+"chkerr") ( Result C(100) , ;
                      Module C(50) , ;
                      IsError L )

if file( cWorkFilDir+"CHKERR.DBF" )
  use (cWorkFilDir+"CHKERR") excl
  zap
  append from (cWorkFilDir+"CHKERR.ERR") SDF
*  DELETE ALL FOR NOT ;
*  ("**" $ Result .OR. "ERROR:" $ UPPER(Result) ;
*  .OR.  "CANNOT" $ upper( Result ) ) 
  PACK
  *DELETE FILE CHKERR.ERR
  IF RECCOUNT() = 0
     RETURN
  ENDIF   
  go top
  lDone = .F.
  lFirst = .T.
  nModRecNo = recno()  && starting record number
  cModName  = substr( Result, 3 )
  
  lOk = .T.  && indicator that operation was successful

  do while !lDone
    lDone = eof()
    if !lFirst and ( substr( Result, 1, 2 ) = "**" or eof() )
      nCurRec = min( recno(), reccount() )
      goto nModRecNo
      delete   && we don't need "**" indicator record any more...
      do while ( recno() < nCurRec or nCurRec = reccount() ) and !eof()
        replace module with cModName
        replace IsError with !lOK
        if lOk  &&  delete references to OK operations
          * delete  && temporary block for testing
        endif
        skip
      enddo
      goto nCurRec
      nModRecNo = recno()  && starting record number
      cModName  = substr( Result, 3 )
      lOk = .T.  && default for next item
    else
      IF not "**" $ Result 
         IF 'UPDATED' $ UPPER(result) .AND. NOT "NOT" $  UPPER(result)
           DO UpdVersions WITH "updated"
         ENDIF
         IF "CREATED" $ UPPER(RESULT) .OR. "ADDING" $ UPPER(RESULT) 
           DO UpdVersions WITH "adding"
         ENDIF
         if "ERROR:" $ upper( Result ) .OR. "CANNOT" $ upper( Result );
           .OR. "NOTE:" $  upper( Result ) 
           lOk = .F.
         ELSE
           IF not "**" $ Result
              DELETE && (AG) 08/05/95
           ENDIF
         ENDIF
      ENDIF
    endif
    lFirst = .F.
    skip
  enddo
  pack
else
  wait "Error Opening Checkin/out Error File!" window
endif
SELECT *;
  FROM CHKERR;  
  WHERE IsError;
  INTO CURSOR temperr
IF USED("chkerr")
  USE IN chkerr
ENDIF
SELECT (curarea)
return


FUNCTION vcstr
* Indicate that module is not a controlled
RETURN("does not exist")

FUNCTION runbatch
* Run batch file
PARAMETERS filename
IF TYPE("m_ace") = 'U'
  PUBLIC m_ace
  m_ace = .f.
ENDIF
IF m_ace
   DO ase WITH filename
ELSE
   !&filename
   =SETDIR(home_dir)
   IF _DOS
     ACTI SCREEN
     set color to (m_background)
     @ 0,0,srows(),scols() box '        '+m_character
     DO sysmes
     SET COLOR TO
   ENDIF
ENDIF
=SETDIR(home_dir)


FUNCTION  UpdVersions
* Update version database for current file
PARAMETERS cMode 


PRIVATE m.projname,m.projdir,nPos, nPos1, m.fullname, ;
     m.date_in, m.time_in, nCount, m.date_mod, m.time_mod, m.userid, nRecno

nRecno = RECNO()

m.projname = ALLTRIM(db_proje->projname)
m.projdir  = ALLTRIM(db_proje->projdir)

* Create version database if not exist
IF !FILE(m.projdir+m_specdir+"\"+m.projname+".VER")
  CREATE DBF (m.projdir+m_specdir+"\"+m.projname+".VER");
      (FULLNAME C(100), VERSION C(20), ;
       DATE_IN D, TIME_IN C(8), DATE_MOD D, TIME_MOD C(8), ;
        USERID C(3) )
  INDEX ON fullname TO (m.projdir+m_specdir+"\"+m.projname+".VMP")
  USE
ENDIF  

=OPENDBF(m.projdir+m_specdir+"\"+m.projname+".VER","VERSIONS")
SET INDEX TO (m.projdir+m_specdir+"\"+m.projname+".VMP")
SET FILTER TO NOT DELETED()
SELE ChkErr
SKIP -1
IF NOT UPPER(SUBSTR(m.name,1,RAT(".",m.name))) $ result && (AG) 02/21/94
  SKIP -1
ENDIF  
m.fullname = UpdateName()
IF EMPTY(m.fullname)
  SELE chkerr
  RETURN
ENDIF  
m.date_in    = DATE()
m.time_in    = TIME()
nCount = ADIR(temparr, m.fullname)
m.date_mod   = temparr(1,3)
m.time_mod   = temparr(1,4)
IF UPPER(cMode) = "UPDATED"
  Private nPos1, nPos2, nPos3, nPos4, m.version, cDateTime, m.time_in, cDate
  Private cUserid, nDefic1, nDefic2, m.year, m.month, m.day, m.date_in
  m.firstname = SUBSTR(m.fullname,RAT("\",m.fullname)+1)
  ans  = ALLTRIM(chkerr.result)
  nPos1 = AT(UPPER(m.firstname),ans)
  nPos2 = nPos1+LEN(ALLTRIM(m.firstname))+1
  nPos3 = AT("`",ans)
  nPos4 = AT("'",ans)
  m.version       = ALLTRIM(SUBSTR(ans,1,nPos1-1))
  cDateTime = ALLTRIM(SUBSTR(ans,nPos2,nPos3-nPos2-1))
  nPos5= AT(",",cDateTime)
  m.time_in = SUBSTR(cDateTime,nPos5+1)
  cDate = SUBSTR(cDateTime,1,nPos5)  
  m.userid   = ALLTRIM(SUBSTR(ans,nPos3+1,nPos4-nPos3-1))  
  nDefic1 = AT("-",cDate)
  nDefic2 = RAT("-",cDate)
  m.year    = ALLTRIM(SUBSTR(cDate,nDefic2+1))
  m.month   = fMonth(UPPER(ALLTRIM(SUBSTR(cDate,nDefic1+1,nDefic2-nDefic1-1))))
  m.day     = ALLTRIM(SUBSTR(cDate,1,nDefic1-1))
  m.date_in    = CTOD(m.month+"/"+m.day+"/"+m.year)
ELSE
       m.version = "1"
ENDIF
SELE versions
IF SEEK(m.fullname)
       GATHER MEMVAR
ELSE
       INSERT INTO versions FROM MEMVAR
ENDIF  
SELE ChkErr  
IF nRecno <= RECCOUNT()
  GOTO nRecno
ENDIF  

FUNCTION UpdateName
PRIVATE nRecno,m.ret_val
nRecno = RECNO()
DO WHILE NOT "**" $ SUBSTR(Result,1,2)
  SKIP -1
  IF EOF()
    GOTO nRecno 
    RETURN ("")
  ENDIF
ENDDO
m.ret_val = UPPER(ALLTRIM(SUBSTR(Result,3)))
GOTO nRecno 
RETURN(m.ret_val)

FUNCTION vertrack
* Create version list
PRIVATE cName, ans,cMemo,nArea, nStart, nEnd, lFirstTime, cComment   
PRIVATE cPos, cPos1, cVer, cUserid, cDateTime, cLine
PRIVATE nPos1, nPos2, nPos3, nPos4
Private nPos1, nPos2, nPos3, nPos4, m.version, cDateTime, m.time_in, cDate
Private cUserid, nDefic1, nDefic2, m.year, m.month, m.day, m.date_in

cMemo = SET("MEMO")
SET MEMO TO 100

SELE 0
CREATE CURSOR VERHIST ;
( VERSION C(5), DATE_IN D, TIME_IN C(8), USERID C(3), COMMENT C(130) )


SELE 0
CREATE CURSOR TempMemo ( temp M)
APPEND BLANK
APPEND MEMO temp FROM HISTORY.TXT

nStart  = atcline(ALLTRIM(UPPER(m.firstname)), temp)
IF !EMPTY(m.secname)
  nEnd    = atcline(ALLTRIM(UPPER(m.secname)),temp)
  DO WHILE NOT ALLTRIM(UPPER(m.firstname)) $ MLINE(temp,nEnd) 
    nEnd = nEnd - 1
  ENDDO
ELSE
  nEnd    = MEMLINES(temp)
ENDIF

cComment = ""
WAIT WINDOW "Creating version database..." NOWAIT 


FOR i = nStart TO nEnd
  ans   = MLINE(temp,i)
  IF EMPTY(ans) .OR. NOT ALLTRIM(UPPER(m.firstname)) $  ans
    LOOP
  ENDIF  
  IF "**********" $ ans
    EXIT
  ENDIF  
  m.firstname = SUBSTR(m.fullname,RAT("\",m.fullname)+1)
  IF ".DBF" $ UPPER(m.firstname) .AND. current.controlled = 'Str'
     m.firstname = STRTRAN(m.firstname,'.DBF',".STR")
  ENDIF  
  nPos1 = AT(UPPER(m.firstname),ans)
  nPos2 = nPos1+LEN(ALLTRIM(m.firstname))+1
  nPos3 = AT("`",ans)
  nPos4 = AT("'",ans)
  m.version       = ALLTRIM(SUBSTR(ans,1,nPos1-1))
  cDateTime = ALLTRIM(SUBSTR(ans,nPos2,nPos3-nPos2-1))
  nPos5= AT(",",cDateTime)
  m.time_in = SUBSTR(cDateTime,nPos5+1)
  cDate = SUBSTR(cDateTime,1,nPos5)  
  m.userid   = ALLTRIM(SUBSTR(ans,nPos3+1,nPos4-nPos3-1))  
  m.comment  = ALLTRIM(SUBSTR(ans,nPos4+1))
  IF EMPTY(m.comment) .AND. ;
      NOT  ALLTRIM(UPPER(m.firstname)) $  MLINE(temp,i+1)
      m.comment = ALLTRIM(MLINE(temp,i+1))
  ENDIF
  nDefic1 = AT("-",cDate)
  nDefic2 = RAT("-",cDate)
  m.year    = ALLTRIM(SUBSTR(cDate,nDefic2+1))
  m.month   = fMonth(UPPER(ALLTRIM(SUBSTR(cDate,nDefic1+1,nDefic2-nDefic1-1))))
  m.day     = ALLTRIM(SUBSTR(cDate,1,nDefic1-1))
  m.date_in    = CTOD(m.month+"/"+m.day+"/"+m.year)

  IF NOT UPPER(m.firstname) $ ans
     EXIT
  ENDIF
  INSERT INTO VERHIST FROM MEMVAR
ENDFOR

SELE VERHIST
WAIT CLEAR
SET MEMO TO (cMemo)

FUNCTION UpdateTempCursor
PRIVATE m.name, nLine, ans,nArea
PRIVATE nSpace1,nSpace2,nSpace3,nSpace4,nSpace5,nPos
PRIVATE m.year, m.month, m.day 
nArea = SELECT()
m.fullname =  ALLTRIM(fullname)
SELE headers
SET ORDER TO name
IF NOT SEEK("**"+m.fullname)
   SET ORDER TO
   SELECT (nArea)
   RETURN (.T.)
ENDIF   

SET ORDER TO
SKIP
IF !EOF()
  m.nRecno = headers.nrecno - 1
  SELE tempstat
  GOTO m.nRecno
ELSE
  SELE tempstat
  GOTO BOTTOM
ENDIF

ans = ALLTRIM(name)
IF "ERROR:" $ ans
  m.error = ans  
  SELECT (nArea)
  RETURN
ENDIF  


  m.firstname = SUBSTR(m.fullname,RAT("\",m.fullname)+1)
  nPos1 = AT(UPPER(m.firstname),ans)
  nPos2 = nPos1+LEN(ALLTRIM(m.firstname))+1
  nPos3 = AT("`",ans)
  nPos4 = AT("'",ans)
  m.version       = ALLTRIM(SUBSTR(ans,1,nPos1-1))
  cDateTime = ALLTRIM(SUBSTR(ans,nPos2,nPos3-nPos2-1))
  nPos5= AT(",",cDateTime)
  m.time = SUBSTR(cDateTime,nPos5+1)
  cDate = SUBSTR(cDateTime,1,nPos5)  
  m.userid   = ALLTRIM(SUBSTR(ans,nPos3+1,nPos4-nPos3-1))  
  m.comment  = ALLTRIM(SUBSTR(ans,nPos4+1))
  nDefic1 = AT("-",cDate)
  nDefic2 = RAT("-",cDate)
  m.year    = ALLTRIM(SUBSTR(cDate,nDefic2+1))
  m.month   = fMonth(UPPER(ALLTRIM(SUBSTR(cDate,nDefic1+1,nDefic2-nDefic1-1))))
  m.day     = ALLTRIM(SUBSTR(cDate,1,nDefic1-1))
  m.date    = CTOD(m.month+"/"+m.day+"/"+m.year)
SELECT (nArea)

FUNCTION fMonth
PARAMETERS m.month
nMonth = "??"
m.month = upper( m.month ) &&  09/28/94 (rg)
    DO CASE
      CASE m.month = "JAN"       
         nMonth = "01"
      CASE m.month = "FEB"      
         nMonth = "02"
      CASE m.month = "MAR"      
         nMonth = "03"
      CASE m.month = "APR"      
         nMonth = "04"
      CASE m.month = "MAY"      
         nMonth = "05"
      CASE m.month = "JUN"      
         nMonth = "06"
      CASE m.month = "JUL"      
         nMonth = "07"
      CASE m.month = "AUG"
         nMonth = "08"
      CASE m.month = "SEP"
         nMonth = "09"
      CASE m.month = "OCT"
         nMonth = "10"
      CASE m.month = "NOV"
         nMonth = "11"
      CASE m.month = "DEC"
         nMonth = "12"
      ENDCASE      
RETURN(nMonth)



